// ImageTarget.cpp: implementation of the CImageTarget class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "ImageTarget.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CWnd * CImageTarget::_pFenetre ;
int CImageTarget::_id = 0 ;

BEGIN_MESSAGE_MAP(CImageTarget, CWnd)
ON_WM_TIMER()
END_MESSAGE_MAP()

CImageTarget::CImageTarget()
{

}
//creation des items -
bool CImageTarget::Create( CWnd * pwnd , CRect & rect , std::string image , bool visible )
{
	bool vRet = false ;
	
	if( pwnd != NULL ) //pour le chef item - for the master item
	{
		ASSERT(::IsWindow( pwnd->m_hWnd ) ) ;

		Attach( pwnd );
	}

	m_timerIsOn = false ;
	m_visible = true ;
	m_rect = rect ;

	m_nomImage = image ;

	HBITMAP hbmp = ( HBITMAP ) :: LoadImage( AfxGetInstanceHandle() , image.c_str() , IMAGE_BITMAP , 0 , 0 ,LR_LOADFROMFILE );

	if( hbmp )
	{
		m_bmp.Attach( hbmp );
		m_visible = visible ;
		m_isSelected = false ;
		vRet = true ;

		BITMAP bm ;
		m_bmp.GetBitmap( &bm );

		m_width = bm.bmWidth ;
		m_height = bm.bmHeight ;

		m_id = ++_id ;

		//cration d' une fentre fantme qui ne sert qu'  pouvoir activer un timer
		//on peut s' en passer si on trouve un autre moyen
		//Creation of an empty window wich will be useful only to receive WM_TIMER message
		//we can always find an other way
		vRet = CWnd::Create( NULL , NULL , WS_DISABLED |WS_CHILD , CRect(0,0,0,0) , _pFenetre, m_id );
	}

	return vRet ;

}
//Ajout d' un subitem
int CImageTarget::AddItem( CRect & rect,  std::string image , bool visible ) 
{
	int vRet = -1 ;
	
	CImageTarget * pItem = new CImageTarget ;

	bool res = pItem->Create( NULL ,  rect ,  image ,  visible ) ;

	if ( res )
	{
		Subordonne( pItem );
	}

	return pItem->m_id ;
	
}
//
CImageTarget::~CImageTarget()
{

}
//Ajout d 'un vnement dans la message map
bool CImageTarget::AddToMap( int idItem , int idmessage , int idCtrl )
{
	bool vRet = false ;

	for( int i = 0 ; i < m_sub.size() ; i ++ )
	{
		if( m_sub[ i ]->m_id  == idItem )
		{
			m_sub[ i ]->m_messageMap[ idmessage ] = idCtrl ; 
			vRet = true ;
		}
	}

	return vRet ;
}
//Pour dessiner
void CImageTarget::Draw( CDC * pDC ) 
{

	if(  m_visible )
	{
		TRACE( "dessin de :   " );
	
		
		TRACE( ( LPCSTR )m_nomImage.c_str() );
		TRACE( "\r\n" );

		CDC tempDC ;
		tempDC.CreateCompatibleDC( pDC );
		tempDC.SelectObject( & m_bmp );

		BLENDFUNCTION blf ;

		blf.AlphaFormat =  0;
		blf.BlendFlags = 0;
		blf.BlendOp = AC_SRC_OVER;

		if( m_isSelected  )				///*|| ( m_sub.size() >0 && m_sub[ 0 ]->m_visible )*/
			blf.SourceConstantAlpha = 160 ;
		else
			blf.SourceConstantAlpha = 80 ;

		//mthodes Win32 SDK
		AlphaBlend(
				  pDC->m_hDC,					
				  m_rect.left,					
				  m_rect.top,					
				  m_rect.Width(),				
				  m_rect.Height(),				
				  tempDC.m_hDC,                 
				  0,							
				  0,							
				  m_width,						
				  m_height,						
				  blf						
						);
	}

	//l' item chef dessine ses propres subordonns
	//the master item draws its own subordonnates
	for( int i = 0 ; i < m_sub.size() ; i ++ )
	{
		m_sub[ i ]->Draw( pDC ) ; 	
	}

}
//Sur dplacement de la souris
bool CImageTarget::MouseMove( CPoint pt )
{
	bool selfSel = false ;
	bool subSel = false ;

	//***************************************************
	//est-ce que lui mme est slectionn ? ( pour tous )
	if( m_rect.PtInRect( pt ) ) 
	{
		selfSel = true ;
	}
	else
	{
		//cas spcial du chef : on peut tre en transition
		//if( m_timerIsOn ) selfSel = true ;
	}
	//cas du subordonn
	if( m_sub.size() == 0 )
	{
		//pour un sub , la slection est soumise  la visibilit
		selfSel = selfSel && m_visible ;

		//si la slection  chang 
		if( m_isSelected != selfSel  )
		{
			TRACE("changement de slection d' un sub \r\n");
			
			m_isSelected = selfSel ;
			SelfInvalidate( );
		}

	}
	else//cas du chef
	{
		//est-ce qu' un subordonn est slectionn ?
		for( int i = 0 ; i < m_sub.size() ; i ++ )
		{
			//aucun MouseMove n' est envoy directement aux sub par l' application
			m_sub[ i ]->MouseMove( pt );
			subSel = subSel | m_sub[ i ]->IsSelected() ;
		}

		if( subSel ) //cas ou on est pass du chef  un sub
		{
			KillTimer();
		}
		else
		{
			TRACE("aucun sub de slctionn \r\n" );
		}

		bool temp = selfSel | subSel ;

		//si la slection  chang 
		if( m_isSelected != temp  )
		{
			m_isSelected = temp ;

			//si le chef n' est plus slectionn
			if (! selfSel )
			{
				TRACE("Abandon de selection de l' item chef \r\n" );
				
				//si un des sub est slectionn
				//on lui a envoy un msg, donc il se redessinera ( voir 4 lignes plus haut )

				//sinon on lance le compte  rebour de destruction
				if( ! subSel  )
				{
					TRACE("aucun sub slctionn \r\n" );

					KillTimer();
					SetTimer();
				}
			}
			else //le chef est slectionn ou re-slectionn aprs un passage  vide
			{

				TRACE("le chef est slectionn \r\n") ;

				//le timer -t-il expir ?
				if( ! m_timerIsOn )
				{
					TRACE("on passe les sub  visible \r\n") ;

					//on passe les sub  visible
					for( int i = 0 ; i < m_sub.size() ; i ++ )
					{
						m_sub[ i ]->SetVisible( true );
						
					}
					SelfInvalidate( );
					InvalidateSub();
				}
				else
				{
						KillTimer();
				}
			}

		}

	}
	
	return ( m_isSelected );
}
//Sur click bouton gauche
bool CImageTarget::LButtonDown( CPoint pt )
{
	bool isOneSubClicked = false ;
	bool isClicked = false ;

	if( m_rect.PtInRect( pt ) ) 
	{
		isClicked = true ;
		
	}

	if( m_sub.size() > 0 ) //cas du chef
	{
		//est-ce qu' un subordonn est slectionn ?
		for( int i = 0 ; i < m_sub.size() ; i ++ )
		{
			//aucun MouseMove n' est envoy directement aux sub par l' application
			isOneSubClicked = isOneSubClicked | m_sub[ i ]->LButtonDown( pt ) ;
		}

		// tout disparat tout le temps sauf si il a click sur le chef
		if( ! isClicked ) m_isSelected = false ;

		KillTimer() ;

		InvisibleSub();
		SelfInvalidate( );
		InvalidateSub();

	}

	if( isClicked )
	{
		TRACE("one is clicked");
		std::map< int , int >::iterator it = m_messageMap.find( WM_LBUTTONDOWN );
		if( it != m_messageMap.end() )
		{
			_pFenetre->SendMessage( WM_COMMAND , it->second );
		}	
	}	

	return ( isClicked | isOneSubClicked );
}
//
void CImageTarget::SetTimer( )
{
	CWnd::SetTimer( 1 , TIMER , NULL );

	m_timerIsOn = true ;
}
//
void CImageTarget::KillTimer(  )
{
	CWnd::KillTimer( 1 ) ;
	m_timerIsOn = false ;
}
//
void CImageTarget::OnTimer(UINT nIDEvent)
{
	KillTimer( );

	if(  m_isSelected )
	{
		SetTimer() ;//On repart pour un tour
	}
	else
	{
		InvisibleSub();
		SelfInvalidate( );
		InvalidateSub();
	}

}
//Invalidation des subordonns
void CImageTarget::InvalidateSub()
{
	for( int i = 0 ; i < m_sub.size() ; i ++ )
	{
		m_sub[ i ] ->SelfInvalidate( );	
	}
}
//Rend les sub. invisibles
void CImageTarget::InvisibleSub()
{
	for( int i = 0 ; i < m_sub.size() ; i ++ )
	{
		m_sub[ i ] ->SetVisible( false );	
	}
}
//Accesseur de visibilit
void CImageTarget::SetVisible( bool cmd )
{
	m_visible = cmd ;
}
