// ImageTarget.h: interface for the CImageTarget class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IMAGETARGET_H__6673D07C_E204_4602_9A65_0897DEECC957__INCLUDED_)
#define AFX_IMAGETARGET_H__6673D07C_E204_4602_9A65_0897DEECC957__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <string>
#include <map>
#include <vector>
	

//delai pour le timer
//ellapse for the timer
const int TIMER = 500 ;

//CImageTarget hrite de CWnd UNIQUEMENT pour pouvoir activer un timer
//CImageTarget inherit from CWnd class ONLY to receive WM_TIMER message
class CImageTarget  : public CWnd
{
	//nom du fichier image
	//name of the image file
	std::string m_nomImage ;
	
	//pour savoir si le timer est activ
	//to know if the timer is on
	bool m_timerIsOn ;

	//compteur d' instance
	//static member that is actually a counter for the instance
	static int _id ;

	//chaque instance de la classe  un identifiant unique
	//each instance owns an unique id
	int m_id ;

	//fentre  laquelle le menu est attach( ncessaire au rafrachissement )
	//Cwnd object to wich the menu is attached ( necessary to repaint the client-screen ) 
	static CWnd * _pFenetre ;

	//pour attacher le menu  une fentre ( pour demander une invalidation )
	//to attach the menu to a CWnd object ( to ask for a invalidation )
	void Attach( CWnd * pWnd ){ _pFenetre = pWnd ;}

	//pour subordonner un item  un autre
	//to subordonnate an item to another
	void Subordonne( CImageTarget * it ){ m_sub.push_back( it ); }

	//chaque instance peut demander son rafraichissement
	//each instance can ask for a repaint
	void SelfInvalidate() { ( ( CView * ) _pFenetre )->InvalidateRect( & m_rect /*NULL*/, TRUE ); }

	//les sub-items disparaissent
	//makes the sub-items invisible
	void InvisibleSub();

	//invalide la zone des sub-items
	//ask for repaint the sub-item
	void InvalidateSub();

protected :

	//rectangle de dessin
	//drawing-in rectangle
	CRect m_rect ;

	//largeur du rectangle de dessin
	//width of the drawing-in rectangle
	int m_width ;

	//hauteur du rectangle de dessin
	//height of the drawing-in rectangle
	int m_height ;

	//bitmap qui sera charg dynamiquement et dessin
	//bitmap wich would be loaded and drawn
	CBitmap m_bmp ;

	//visibilit et slection de l' item du menu
	//visibility and selection of the item
	bool m_visible ;
	bool m_isSelected ;

	//vector de subordonns ou sous-items
	//subitems or subordonates vector
	std::vector< CImageTarget *> m_sub ;

	//message-map
	std::map< int , int > m_messageMap ;

	void SetTimer(  );
	void KillTimer(  );

public:	

	CImageTarget();
	virtual ~CImageTarget();

	//mthode de cration de l' item "chef"
	//creation of the "master" item
	bool Create( CWnd * pwnd , CRect & rect , std::string image , bool visible ) ;

	//Ajout d' un sub-item
	//To add a subitem
	int AddItem( CRect & rect , std::string image , bool visible ) ;

	//mthode de dessin
	//drawing method
	void Draw( CDC * pDC ) ;

	//ajoute un vnement dans la message map de l' item idItem
	//Add an evenement into the message-map of the idItem item
	bool AddToMap( int idItem , int idmessage , int idCtrl ) ;

	//deux principaux vnement sur lesquels vont ragir les items de menus ( on peut en ajouter d' autres )
	//two main evenements on wich the items will react on ( you can add more )
	bool MouseMove( CPoint pt );
	bool LButtonDown( CPoint pt );
	
	//accesseur
	//accessor
	void SetVisible( bool cmd );
	void SetSelected( bool cmd ){ 	m_isSelected = cmd ;	}

	bool IsVisible() { return m_visible; }
	bool IsSelected() { return m_isSelected; }

	CRect GetRect(){ return m_rect ; }
	void SetRect( CRect & rect ){  m_rect = rect; }

	afx_msg void OnTimer(UINT nIDEvent);

	DECLARE_MESSAGE_MAP()
};

#endif // !defined(AFX_IMAGETARGET_H__6673D07C_E204_4602_9A65_0897DEECC957__INCLUDED_)
